#ifndef _H_1E55B60AF9DB437833E067D328A8F0C2_DetectedRadarObject_DCPS_H_
#define _H_1E55B60AF9DB437833E067D328A8F0C2_DetectedRadarObject_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "DetectedRadarObject_.h"


namespace lgsvl_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class DetectedRadarObject_TypeSupportInterface;

            typedef DetectedRadarObject_TypeSupportInterface * DetectedRadarObject_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < DetectedRadarObject_TypeSupportInterface> DetectedRadarObject_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < DetectedRadarObject_TypeSupportInterface> DetectedRadarObject_TypeSupportInterface_out;


            class DetectedRadarObject_DataWriter;

            typedef DetectedRadarObject_DataWriter * DetectedRadarObject_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < DetectedRadarObject_DataWriter> DetectedRadarObject_DataWriter_var;
            typedef DDS_DCPSInterface_out < DetectedRadarObject_DataWriter> DetectedRadarObject_DataWriter_out;


            class DetectedRadarObject_DataReader;

            typedef DetectedRadarObject_DataReader * DetectedRadarObject_DataReader_ptr;
            typedef DDS_DCPSInterface_var < DetectedRadarObject_DataReader> DetectedRadarObject_DataReader_var;
            typedef DDS_DCPSInterface_out < DetectedRadarObject_DataReader> DetectedRadarObject_DataReader_out;


            class DetectedRadarObject_DataReaderView;

            typedef DetectedRadarObject_DataReaderView * DetectedRadarObject_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < DetectedRadarObject_DataReaderView> DetectedRadarObject_DataReaderView_var;
            typedef DDS_DCPSInterface_out < DetectedRadarObject_DataReaderView> DetectedRadarObject_DataReaderView_out;

            struct DetectedRadarObject_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < DetectedRadarObject_, struct DetectedRadarObject_Seq_uniq_> DetectedRadarObject_Seq;
            typedef DDS_DCPSSequence_var < DetectedRadarObject_Seq> DetectedRadarObject_Seq_var;
            typedef DDS_DCPSSequence_out < DetectedRadarObject_Seq> DetectedRadarObject_Seq_out;

            class  DetectedRadarObject_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef DetectedRadarObject_TypeSupportInterface_ptr _ptr_type;
                typedef DetectedRadarObject_TypeSupportInterface_var _var_type;

                static DetectedRadarObject_TypeSupportInterface_ptr _duplicate (DetectedRadarObject_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static DetectedRadarObject_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static DetectedRadarObject_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static DetectedRadarObject_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                DetectedRadarObject_TypeSupportInterface_ptr _this () { return this; }


            protected:
                DetectedRadarObject_TypeSupportInterface () {};
                ~DetectedRadarObject_TypeSupportInterface () {};
            private:
                DetectedRadarObject_TypeSupportInterface (const DetectedRadarObject_TypeSupportInterface &);
                DetectedRadarObject_TypeSupportInterface & operator = (const DetectedRadarObject_TypeSupportInterface &);
            };

            class  DetectedRadarObject_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef DetectedRadarObject_DataWriter_ptr _ptr_type;
                typedef DetectedRadarObject_DataWriter_var _var_type;

                static DetectedRadarObject_DataWriter_ptr _duplicate (DetectedRadarObject_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static DetectedRadarObject_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static DetectedRadarObject_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static DetectedRadarObject_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                DetectedRadarObject_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const DetectedRadarObject_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const DetectedRadarObject_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const DetectedRadarObject_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const DetectedRadarObject_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const DetectedRadarObject_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const DetectedRadarObject_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const DetectedRadarObject_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const DetectedRadarObject_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const DetectedRadarObject_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const DetectedRadarObject_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (DetectedRadarObject_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const DetectedRadarObject_& instance_data) = 0;

            protected:
                DetectedRadarObject_DataWriter () {};
                ~DetectedRadarObject_DataWriter () {};
            private:
                DetectedRadarObject_DataWriter (const DetectedRadarObject_DataWriter &);
                DetectedRadarObject_DataWriter & operator = (const DetectedRadarObject_DataWriter &);
            };

            class  DetectedRadarObject_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef DetectedRadarObject_DataReader_ptr _ptr_type;
                typedef DetectedRadarObject_DataReader_var _var_type;

                static DetectedRadarObject_DataReader_ptr _duplicate (DetectedRadarObject_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static DetectedRadarObject_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static DetectedRadarObject_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static DetectedRadarObject_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                DetectedRadarObject_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (DetectedRadarObject_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (DetectedRadarObject_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (DetectedRadarObject_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (DetectedRadarObject_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (DetectedRadarObject_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (DetectedRadarObject_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (DetectedRadarObject_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (DetectedRadarObject_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (DetectedRadarObject_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (DetectedRadarObject_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (DetectedRadarObject_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (DetectedRadarObject_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (DetectedRadarObject_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (DetectedRadarObject_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const DetectedRadarObject_& instance) = 0;

            protected:
                DetectedRadarObject_DataReader () {};
                ~DetectedRadarObject_DataReader () {};
            private:
                DetectedRadarObject_DataReader (const DetectedRadarObject_DataReader &);
                DetectedRadarObject_DataReader & operator = (const DetectedRadarObject_DataReader &);
            };

            class  DetectedRadarObject_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef DetectedRadarObject_DataReaderView_ptr _ptr_type;
                typedef DetectedRadarObject_DataReaderView_var _var_type;

                static DetectedRadarObject_DataReaderView_ptr _duplicate (DetectedRadarObject_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static DetectedRadarObject_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static DetectedRadarObject_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static DetectedRadarObject_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                DetectedRadarObject_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (DetectedRadarObject_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (DetectedRadarObject_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (DetectedRadarObject_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (DetectedRadarObject_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (DetectedRadarObject_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (DetectedRadarObject_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (DetectedRadarObject_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (DetectedRadarObject_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (DetectedRadarObject_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (DetectedRadarObject_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (DetectedRadarObject_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (DetectedRadarObject_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (DetectedRadarObject_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (DetectedRadarObject_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const DetectedRadarObject_& instance) = 0;

            protected:
                DetectedRadarObject_DataReaderView () {};
                ~DetectedRadarObject_DataReaderView () {};
            private:
                DetectedRadarObject_DataReaderView (const DetectedRadarObject_DataReaderView &);
                DetectedRadarObject_DataReaderView & operator = (const DetectedRadarObject_DataReaderView &);
            };
        }

    }

}

#endif
