#ifndef _H_BD677A83CBBFE0B6E483696D9F21DC89_Ultrasonic_DCPS_H_
#define _H_BD677A83CBBFE0B6E483696D9F21DC89_Ultrasonic_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "Ultrasonic_.h"


namespace lgsvl_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class Ultrasonic_TypeSupportInterface;

            typedef Ultrasonic_TypeSupportInterface * Ultrasonic_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Ultrasonic_TypeSupportInterface> Ultrasonic_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Ultrasonic_TypeSupportInterface> Ultrasonic_TypeSupportInterface_out;


            class Ultrasonic_DataWriter;

            typedef Ultrasonic_DataWriter * Ultrasonic_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Ultrasonic_DataWriter> Ultrasonic_DataWriter_var;
            typedef DDS_DCPSInterface_out < Ultrasonic_DataWriter> Ultrasonic_DataWriter_out;


            class Ultrasonic_DataReader;

            typedef Ultrasonic_DataReader * Ultrasonic_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Ultrasonic_DataReader> Ultrasonic_DataReader_var;
            typedef DDS_DCPSInterface_out < Ultrasonic_DataReader> Ultrasonic_DataReader_out;


            class Ultrasonic_DataReaderView;

            typedef Ultrasonic_DataReaderView * Ultrasonic_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Ultrasonic_DataReaderView> Ultrasonic_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Ultrasonic_DataReaderView> Ultrasonic_DataReaderView_out;

            struct Ultrasonic_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Ultrasonic_, struct Ultrasonic_Seq_uniq_> Ultrasonic_Seq;
            typedef DDS_DCPSSequence_var < Ultrasonic_Seq> Ultrasonic_Seq_var;
            typedef DDS_DCPSSequence_out < Ultrasonic_Seq> Ultrasonic_Seq_out;

            class  Ultrasonic_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Ultrasonic_TypeSupportInterface_ptr _ptr_type;
                typedef Ultrasonic_TypeSupportInterface_var _var_type;

                static Ultrasonic_TypeSupportInterface_ptr _duplicate (Ultrasonic_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Ultrasonic_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Ultrasonic_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Ultrasonic_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Ultrasonic_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Ultrasonic_TypeSupportInterface () {};
                ~Ultrasonic_TypeSupportInterface () {};
            private:
                Ultrasonic_TypeSupportInterface (const Ultrasonic_TypeSupportInterface &);
                Ultrasonic_TypeSupportInterface & operator = (const Ultrasonic_TypeSupportInterface &);
            };

            class  Ultrasonic_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Ultrasonic_DataWriter_ptr _ptr_type;
                typedef Ultrasonic_DataWriter_var _var_type;

                static Ultrasonic_DataWriter_ptr _duplicate (Ultrasonic_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Ultrasonic_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Ultrasonic_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Ultrasonic_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Ultrasonic_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Ultrasonic_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Ultrasonic_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Ultrasonic_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Ultrasonic_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Ultrasonic_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Ultrasonic_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Ultrasonic_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Ultrasonic_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Ultrasonic_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Ultrasonic_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Ultrasonic_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Ultrasonic_& instance_data) = 0;

            protected:
                Ultrasonic_DataWriter () {};
                ~Ultrasonic_DataWriter () {};
            private:
                Ultrasonic_DataWriter (const Ultrasonic_DataWriter &);
                Ultrasonic_DataWriter & operator = (const Ultrasonic_DataWriter &);
            };

            class  Ultrasonic_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Ultrasonic_DataReader_ptr _ptr_type;
                typedef Ultrasonic_DataReader_var _var_type;

                static Ultrasonic_DataReader_ptr _duplicate (Ultrasonic_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Ultrasonic_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Ultrasonic_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Ultrasonic_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Ultrasonic_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Ultrasonic_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Ultrasonic_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Ultrasonic_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Ultrasonic_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Ultrasonic_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Ultrasonic_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Ultrasonic_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Ultrasonic_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Ultrasonic_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Ultrasonic_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Ultrasonic_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Ultrasonic_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Ultrasonic_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Ultrasonic_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Ultrasonic_& instance) = 0;

            protected:
                Ultrasonic_DataReader () {};
                ~Ultrasonic_DataReader () {};
            private:
                Ultrasonic_DataReader (const Ultrasonic_DataReader &);
                Ultrasonic_DataReader & operator = (const Ultrasonic_DataReader &);
            };

            class  Ultrasonic_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Ultrasonic_DataReaderView_ptr _ptr_type;
                typedef Ultrasonic_DataReaderView_var _var_type;

                static Ultrasonic_DataReaderView_ptr _duplicate (Ultrasonic_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Ultrasonic_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Ultrasonic_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Ultrasonic_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Ultrasonic_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Ultrasonic_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Ultrasonic_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Ultrasonic_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Ultrasonic_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Ultrasonic_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Ultrasonic_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Ultrasonic_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Ultrasonic_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Ultrasonic_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Ultrasonic_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Ultrasonic_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Ultrasonic_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Ultrasonic_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Ultrasonic_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Ultrasonic_& instance) = 0;

            protected:
                Ultrasonic_DataReaderView () {};
                ~Ultrasonic_DataReaderView () {};
            private:
                Ultrasonic_DataReaderView (const Ultrasonic_DataReaderView &);
                Ultrasonic_DataReaderView & operator = (const Ultrasonic_DataReaderView &);
            };
        }

    }

}

#endif
