#ifndef _H_4F76F25B83111D8278308FAC565EE1EE_VehicleOdometry__H_
#define _H_4F76F25B83111D8278308FAC565EE1EE_VehicleOdometry__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "std_msgs/msg/dds_opensplice/Header_.h"


namespace lgsvl_msgs
{
    namespace msg
    {
        namespace dds_
        {
            struct  VehicleOdometry_
            {
                ::std_msgs::msg::dds_::Header_ header_;
                ::DDS::Float velocity_;
                ::DDS::Float front_wheel_angle_;
                ::DDS::Float rear_wheel_angle_;
            };

            typedef DDS_DCPSStruct_var<VehicleOdometry_> VehicleOdometry__var;
            typedef DDS_DCPSStruct_out < VehicleOdometry_> VehicleOdometry__out;

        }

    }

}

#endif /* _H_4F76F25B83111D8278308FAC565EE1EE_VehicleOdometry__H_ */
