#ifndef _H_9C3799D8CFD84D4884219A928F516387_VehicleStateData__H_
#define _H_9C3799D8CFD84D4884219A928F516387_VehicleStateData__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "std_msgs/msg/dds_opensplice/Header_.h"


namespace lgsvl_msgs
{
    namespace msg
    {
        namespace dds_
        {
            namespace VehicleStateData_Constants
            {
                const ::DDS::Octet BLINKERS_OFF_ = 0;

                const ::DDS::Octet BLINKERS_LEFT_ = 1;

                const ::DDS::Octet BLINKERS_RIGHT_ = 2;

                const ::DDS::Octet BLINKERS_HAZARD_ = 3;

                const ::DDS::Octet HEADLIGHTS_OFF_ = 0;

                const ::DDS::Octet HEADLIGHTS_LOW_ = 1;

                const ::DDS::Octet HEADLIGHTS_HIGH_ = 2;

                const ::DDS::Octet WIPERS_OFF_ = 0;

                const ::DDS::Octet WIPERS_LOW_ = 1;

                const ::DDS::Octet WIPERS_MED_ = 2;

                const ::DDS::Octet WIPERS_HIGH_ = 3;

                const ::DDS::Octet GEAR_NEUTRAL_ = 0;

                const ::DDS::Octet GEAR_DRIVE_ = 1;

                const ::DDS::Octet GEAR_REVERSE_ = 2;

                const ::DDS::Octet GEAR_PARKING_ = 3;

                const ::DDS::Octet GEAR_LOW_ = 4;

                const ::DDS::Octet VEHICLE_MODE_COMPLETE_MANUAL_ = 0;

                const ::DDS::Octet VEHICLE_MODE_COMPLETE_AUTO_DRIVE_ = 1;

                const ::DDS::Octet VEHICLE_MODE_AUTO_STEER_ONLY_ = 2;

                const ::DDS::Octet VEHICLE_MODE_AUTO_SPEED_ONLY_ = 3;

                const ::DDS::Octet VEHICLE_MODE_EMERGENCY_MODE_ = 4;

            }

            struct  VehicleStateData_
            {
                ::std_msgs::msg::dds_::Header_ header_;
                ::DDS::Octet blinker_state_;
                ::DDS::Octet headlight_state_;
                ::DDS::Octet wiper_state_;
                ::DDS::Octet current_gear_;
                ::DDS::Octet vehicle_mode_;
                ::DDS::Boolean hand_brake_active_;
                ::DDS::Boolean horn_active_;
                ::DDS::Boolean autonomous_mode_active_;
            };

            typedef DDS_DCPSStruct_var<VehicleStateData_> VehicleStateData__var;
            typedef DDS_DCPSStruct_out < VehicleStateData_> VehicleStateData__out;

        }

    }

}

#endif /* _H_9C3799D8CFD84D4884219A928F516387_VehicleStateData__H_ */
