#ifndef _H_9C3799D8CFD84D4884219A928F516387_VehicleStateData_DCPS_H_
#define _H_9C3799D8CFD84D4884219A928F516387_VehicleStateData_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "VehicleStateData_.h"


namespace lgsvl_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class VehicleStateData_TypeSupportInterface;

            typedef VehicleStateData_TypeSupportInterface * VehicleStateData_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < VehicleStateData_TypeSupportInterface> VehicleStateData_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < VehicleStateData_TypeSupportInterface> VehicleStateData_TypeSupportInterface_out;


            class VehicleStateData_DataWriter;

            typedef VehicleStateData_DataWriter * VehicleStateData_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < VehicleStateData_DataWriter> VehicleStateData_DataWriter_var;
            typedef DDS_DCPSInterface_out < VehicleStateData_DataWriter> VehicleStateData_DataWriter_out;


            class VehicleStateData_DataReader;

            typedef VehicleStateData_DataReader * VehicleStateData_DataReader_ptr;
            typedef DDS_DCPSInterface_var < VehicleStateData_DataReader> VehicleStateData_DataReader_var;
            typedef DDS_DCPSInterface_out < VehicleStateData_DataReader> VehicleStateData_DataReader_out;


            class VehicleStateData_DataReaderView;

            typedef VehicleStateData_DataReaderView * VehicleStateData_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < VehicleStateData_DataReaderView> VehicleStateData_DataReaderView_var;
            typedef DDS_DCPSInterface_out < VehicleStateData_DataReaderView> VehicleStateData_DataReaderView_out;

            struct VehicleStateData_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < VehicleStateData_, struct VehicleStateData_Seq_uniq_> VehicleStateData_Seq;
            typedef DDS_DCPSSequence_var < VehicleStateData_Seq> VehicleStateData_Seq_var;
            typedef DDS_DCPSSequence_out < VehicleStateData_Seq> VehicleStateData_Seq_out;

            class  VehicleStateData_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef VehicleStateData_TypeSupportInterface_ptr _ptr_type;
                typedef VehicleStateData_TypeSupportInterface_var _var_type;

                static VehicleStateData_TypeSupportInterface_ptr _duplicate (VehicleStateData_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static VehicleStateData_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static VehicleStateData_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static VehicleStateData_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                VehicleStateData_TypeSupportInterface_ptr _this () { return this; }


            protected:
                VehicleStateData_TypeSupportInterface () {};
                ~VehicleStateData_TypeSupportInterface () {};
            private:
                VehicleStateData_TypeSupportInterface (const VehicleStateData_TypeSupportInterface &);
                VehicleStateData_TypeSupportInterface & operator = (const VehicleStateData_TypeSupportInterface &);
            };

            class  VehicleStateData_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef VehicleStateData_DataWriter_ptr _ptr_type;
                typedef VehicleStateData_DataWriter_var _var_type;

                static VehicleStateData_DataWriter_ptr _duplicate (VehicleStateData_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static VehicleStateData_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static VehicleStateData_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static VehicleStateData_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                VehicleStateData_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const VehicleStateData_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const VehicleStateData_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const VehicleStateData_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const VehicleStateData_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const VehicleStateData_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const VehicleStateData_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const VehicleStateData_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const VehicleStateData_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const VehicleStateData_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const VehicleStateData_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (VehicleStateData_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const VehicleStateData_& instance_data) = 0;

            protected:
                VehicleStateData_DataWriter () {};
                ~VehicleStateData_DataWriter () {};
            private:
                VehicleStateData_DataWriter (const VehicleStateData_DataWriter &);
                VehicleStateData_DataWriter & operator = (const VehicleStateData_DataWriter &);
            };

            class  VehicleStateData_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef VehicleStateData_DataReader_ptr _ptr_type;
                typedef VehicleStateData_DataReader_var _var_type;

                static VehicleStateData_DataReader_ptr _duplicate (VehicleStateData_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static VehicleStateData_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static VehicleStateData_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static VehicleStateData_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                VehicleStateData_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (VehicleStateData_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (VehicleStateData_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (VehicleStateData_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (VehicleStateData_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (VehicleStateData_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (VehicleStateData_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (VehicleStateData_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (VehicleStateData_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (VehicleStateData_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (VehicleStateData_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (VehicleStateData_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (VehicleStateData_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (VehicleStateData_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (VehicleStateData_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const VehicleStateData_& instance) = 0;

            protected:
                VehicleStateData_DataReader () {};
                ~VehicleStateData_DataReader () {};
            private:
                VehicleStateData_DataReader (const VehicleStateData_DataReader &);
                VehicleStateData_DataReader & operator = (const VehicleStateData_DataReader &);
            };

            class  VehicleStateData_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef VehicleStateData_DataReaderView_ptr _ptr_type;
                typedef VehicleStateData_DataReaderView_var _var_type;

                static VehicleStateData_DataReaderView_ptr _duplicate (VehicleStateData_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static VehicleStateData_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static VehicleStateData_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static VehicleStateData_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                VehicleStateData_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (VehicleStateData_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (VehicleStateData_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (VehicleStateData_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (VehicleStateData_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (VehicleStateData_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (VehicleStateData_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (VehicleStateData_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (VehicleStateData_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (VehicleStateData_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (VehicleStateData_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (VehicleStateData_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (VehicleStateData_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (VehicleStateData_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (VehicleStateData_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const VehicleStateData_& instance) = 0;

            protected:
                VehicleStateData_DataReaderView () {};
                ~VehicleStateData_DataReaderView () {};
            private:
                VehicleStateData_DataReaderView (const VehicleStateData_DataReaderView &);
                VehicleStateData_DataReaderView & operator = (const VehicleStateData_DataReaderView &);
            };
        }

    }

}

#endif
